import _extends from "@babel/runtime/helpers/esm/extends";
import partial from 'lodash.partial';
import { as } from './as';
import { makeTestEnvironment } from './make-test-environment';
import { shouldProduceEvent } from './should-produce-event';
import { shouldThrow } from './should-throw';
import { setSecretsManager, withSecretsManager } from './with-secrets-manager';
export var command = function command(context, name, payload) {
  var command = {
    name: name,
    payload: payload
  };

  var commandContext = _extends({}, context, {
    command: command,
    environment: makeTestEnvironment(_extends({}, context, {
      command: command
    }))
  });

  return Object.assign(commandContext.environment.promise, {
    as: partial(as, commandContext),
    withSecretsManager: partial(withSecretsManager, commandContext),
    setSecretsManager: partial(setSecretsManager, commandContext),
    shouldProduceEvent: partial(shouldProduceEvent, commandContext),
    shouldThrow: partial(shouldThrow, commandContext)
  });
};
//# sourceMappingURL=command.js.map