import isEqual from 'lodash.isequal';
import { makeAssertions } from './make-assertions';
import { stringifyShouldExecuteQueryFailure } from '../../utils/format';
export var shouldExecuteQuery = function shouldExecuteQuery(context, query) {
  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Assertion cannot be assigned if the test was executed.");
  }

  environment.addAssertion(function (resolve, reject, result, error) {
    if (error) {
      return reject(new Error("expected a value, but received an error " + error));
    }

    var index = result ? result.queries.findIndex(function (executed) {
      return isEqual(executed, query);
    }) : -1;

    if (index >= 0) {
      return resolve(result);
    }

    return reject(new Error(stringifyShouldExecuteQueryFailure(query, result.queries)));
  });
  return makeAssertions(context);
};
//# sourceMappingURL=should-execute-query.js.map