"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.as = void 0;

var _lodash = _interopRequireDefault(require("lodash.partial"));

var _shouldProduceEvent = require("./should-produce-event");

var _shouldThrow = require("./should-throw");

var _withSecretsManager = require("./with-secrets-manager");

var as = function as(context, authToken) {
  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Authorization token cannot be assigned if the test was executed.");
  }

  environment.setAuthToken(authToken);
  return Object.assign(environment.promise, {
    shouldProduceEvent: (0, _lodash["default"])(_shouldProduceEvent.shouldProduceEvent, context),
    shouldThrow: (0, _lodash["default"])(_shouldThrow.shouldThrow, context),
    withSecretsManager: (0, _lodash["default"])(_withSecretsManager.withSecretsManager, context),
    setSecretsManager: (0, _lodash["default"])(_withSecretsManager.setSecretsManager, context)
  });
};

exports.as = as;
//# sourceMappingURL=as.js.map