"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.withSecretsManager = void 0;

var _lodash = _interopRequireDefault(require("lodash.partial"));

var _withAdapter = require("./with-adapter");

var _withEncryption = require("./with-encryption");

var _allowSideEffects = require("./allow-side-effects");

var _startSideEffectsFrom = require("./start-side-effects-from");

var _makeAssertions = require("./make-assertions");

var withSecretsManager = function withSecretsManager(context, manager) {
  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Secrets manager cannot be assigned if the test was executed.");
  }

  environment.setSecretsManager(manager);
  return Object.assign((0, _makeAssertions.makeAssertions)(context), {
    withAdapter: (0, _lodash["default"])(_withAdapter.withAdapter, context),
    withEncryption: (0, _lodash["default"])(_withEncryption.withEncryption, context),
    allowSideEffects: (0, _lodash["default"])(_allowSideEffects.allowSideEffects, context),
    startSideEffectsFrom: (0, _lodash["default"])(_startSideEffectsFrom.startSideEffectsFrom, context)
  });
};

exports.withSecretsManager = withSecretsManager;
//# sourceMappingURL=with-secrets-manager.js.map